unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, StdCtrls, TAGraph, TASeries, TADbSource;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    Button1: TButton;
    Chart1: TChart;
    Chart1BarSeries1: TBarSeries;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Splitter1: TSplitter;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure PlotDB;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TAChartUtils;

const
  DB_NAME = 'test.db';

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  BufDataset1.Open;
  PlotDB;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  N = 5;
var
  i: Integer;
begin
  BufDataset1.FileName := Application.Location + DB_NAME;

  if not FileExists(BufDataset1.FileName) then
  begin
    BufDataset1.FieldDefs.Add('Niederlassung', ftString, 10);
    BufDataset1.FieldDefs.Add('Anzahl', ftInteger);
    BufDataset1.FieldDefs.Add('Farbe', ftString, 10);
    BufDataset1.CreateDataset;

    BufDataset1.InsertRecord(['Hamburg', 134, '#FF0000']);
    BufDataset1.InsertRecord(['Berln', 345, '#0000FF']);
    BufDataset1.InsertRecord(['München', 201, '#FFFF00']);
    BufDataset1.InsertRecord(['Frankfurt', 189, '#00FF00']);
    BufDataset1.InsertRecord(['Köln', 235, '#000000']);

    PlotDB;
  end;
end;

function HTMLToColor(AColor: String): TColor;
var
  r, g, b: byte;
begin
  r := StrToInt('$'+copy(AColor, 2, 2));
  g := StrToInt('$'+copy(AColor, 4, 2));
  b := StrToInt('$'+copy(AColor, 6, 2));
  Result := RGBToColor(r, g, b);
end;

procedure TForm1.PlotDB;
var
  y: Integer;
  txt: String;
  farbe: String;
  clr: TColor;
  bm: TBookmark;
begin
  // Bisherige Series löschen
  Chart1BarSeries1.Clear;

  // Dataset manuell durchlaufen und Daten in die Series kopieren

  // Zuvor die visuellen Komponenten von der Datenquelle trennen, sonst
  // laufen die mit...
  DataSource1.Dataset := nil;

  bm := BufDataset1.Getbookmark;
  BufDataset1.First;
  while not BufDataset1.EoF do
  begin
    txt := BufDataset1.FieldByName('Niederlassung').AsString;
    y := BufDataset1.FieldByName('Anzahl').AsInteger;
    farbe := BufDataset1.FieldByName('Farbe').AsString;
    clr := HTMLToColor(farbe);
    Chart1BarSeries1.AddY(y, txt, clr);
    BufDataset1.Next;
  end;

  // Visuelle Controls neu verbinden
  BufDataset1.GotoBookmark(bm);
  BufDataset1.FreeBookmark(bm);
  Datasource1.Dataset := BufDataset1;

  // Chart einrichten
  Chart1.Margins.Bottom := 0;  // sieht besser aus
  // Beschriftung der x-Achse
  Chart1.BottomAxis.Marks.Source := Chart1BarSeries1.Source;  // Texte aus Dataset verwenden
  Chart1.BottomAxis.Marks.Style := smsLabel;
  Chart1.BottomAxis.Title.Caption := 'Niederlassung';
  Chart1.BottomAxis.Title.Visible := true;
  // Beschriftung der y-Achse
  Chart1.LeftAxis.Title.Caption := 'Anzahl';
  Chart1.LeftAxis.Title.Visible := true;
end;

end.

